/*	Copyright 1989 Brown University -- Steven P. Reiss		*/

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X.h>
#include <X11/Xatom.h>

#define FALSE 0

main(argc,argv)
   int argc;
   char ** argv;
{
   Display * dpy;
   int ct,screen,depth,i;
   Window wind,root,w1,w2,w3;
   GC gc;
   XSizeHints sh;
   XEvent xev;
   XButtonPressedEvent *ev;
   XWindowAttributes attrs;
   XSetWindowAttributes sattrs;
   Font ft;

   dpy = XOpenDisplay(0);
   if (dpy == 0) {
      fprintf("Can't open display\n");
      exit(1);
    };
   XSynchronize(dpy,1);

   screen = XDefaultScreen(dpy);

   root = RootWindow(dpy,screen);
   depth = DisplayPlanes(dpy,screen);

   sattrs.event_mask = ExposureMask | ButtonPressMask;

   wind = XCreateWindow(dpy,root,100,100,400,400,3,depth,InputOutput,
			   CopyFromParent,
			   CWEventMask,&sattrs);

   sh.flags = USPosition|USSize;
   sh.x = 100;
   sh.y = 100;
   sh.width = 400;
   sh.height = 400;
   XSetStandardProperties(dpy,wind,"test47","test47",None,argc,argv,&sh);
   XMapWindow(dpy,wind);

   for ( ; ; ) {
      while (XCheckWindowEvent(dpy,wind,~0,&xev));
      XGetWindowAttributes(dpy,wind,&attrs);
      if (attrs.map_state == IsViewable) break;
    };

   w1 = XCreateWindow(dpy,wind,20,20,200,200,3,0,InputOutput,CopyFromParent,
			 0, &sattrs);
   XMapWindow(dpy,w1);

   w2 = XCreateWindow(dpy,w1,20,20,100,100,3,0,InputOutput,CopyFromParent,
			 0, &sattrs);
   XMapWindow(dpy,w2);

   printf("windows: 0x%x 0x%x 0x%x\n",wind,w1,w2);

   while (1)	   {
      XNextEvent(dpy, &xev);
      if (xev.type == ButtonPress) {
	 ev = (XButtonPressedEvent *) &xev;
	 printf("Button: window: 0x%x subwin: 0x%x\n",
		   ev->window,ev->subwindow);
       };
    }
};
